/* reverseString.cpp tests functions reverse() and swap().
 * ...
 *********************************************************/
 
#include <iostream>
#include <string>
using namespace std;

void swap(char& first, char& second);
string reverse(const string& originalString);

int main()
{
  cout << "Enter a line of text: ";
  string aLine;
  getline(cin, aLine);
  
  string reversedLine = reverse(aLine);
  
  cout << reversedLine << endl;
}

/* swap exchanges the values of two variables.
 *
 * Receive:   first, a (char) variable
 *            second, a (char) variable
 * Send back: first, containing the value of second
 *            second, containing the value of first
 *******************************************************/

void swap(char& first, char& second)
{
   char temporary = first;

   first = second;
   second = temporary;
}

/* reverse() reverses the characters in a string
 *
 * Receive: originalString, a string.
 * Return: a string containing the chars of originalString
 *          in reverse order.
 *********************************************************/
string reverse(const string& originalString)
{
   string resultString = originalString;
   int begin = 0,
       end = resultString.size() - 1;

   while (begin < end)
   {
      swap(resultString[begin], resultString[end]);
      begin++;
      end--;
   }

   return resultString;
}